# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['FirewallAuthPortalArgs', 'FirewallAuthPortal']

@pulumi.input_type
class FirewallAuthPortalArgs:
    def __init__(__self__, *,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 groups: Optional[pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]]] = None,
                 identity_based_route: Optional[pulumi.Input[str]] = None,
                 portal_addr: Optional[pulumi.Input[str]] = None,
                 portal_addr6: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a FirewallAuthPortal resource.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]] groups: Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        :param pulumi.Input[str] identity_based_route: Name of the identity-based route that applies to this portal.
        :param pulumi.Input[str] portal_addr: Address (or FQDN) of the authentication portal.
        :param pulumi.Input[str] portal_addr6: IPv6 address (or FQDN) of authentication portal.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if groups is not None:
            pulumi.set(__self__, "groups", groups)
        if identity_based_route is not None:
            pulumi.set(__self__, "identity_based_route", identity_based_route)
        if portal_addr is not None:
            pulumi.set(__self__, "portal_addr", portal_addr)
        if portal_addr6 is not None:
            pulumi.set(__self__, "portal_addr6", portal_addr6)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter
    def groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]]]:
        """
        Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        """
        return pulumi.get(self, "groups")

    @groups.setter
    def groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]]]):
        pulumi.set(self, "groups", value)

    @property
    @pulumi.getter(name="identityBasedRoute")
    def identity_based_route(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the identity-based route that applies to this portal.
        """
        return pulumi.get(self, "identity_based_route")

    @identity_based_route.setter
    def identity_based_route(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "identity_based_route", value)

    @property
    @pulumi.getter(name="portalAddr")
    def portal_addr(self) -> Optional[pulumi.Input[str]]:
        """
        Address (or FQDN) of the authentication portal.
        """
        return pulumi.get(self, "portal_addr")

    @portal_addr.setter
    def portal_addr(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "portal_addr", value)

    @property
    @pulumi.getter(name="portalAddr6")
    def portal_addr6(self) -> Optional[pulumi.Input[str]]:
        """
        IPv6 address (or FQDN) of authentication portal.
        """
        return pulumi.get(self, "portal_addr6")

    @portal_addr6.setter
    def portal_addr6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "portal_addr6", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _FirewallAuthPortalState:
    def __init__(__self__, *,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 groups: Optional[pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]]] = None,
                 identity_based_route: Optional[pulumi.Input[str]] = None,
                 portal_addr: Optional[pulumi.Input[str]] = None,
                 portal_addr6: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering FirewallAuthPortal resources.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]] groups: Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        :param pulumi.Input[str] identity_based_route: Name of the identity-based route that applies to this portal.
        :param pulumi.Input[str] portal_addr: Address (or FQDN) of the authentication portal.
        :param pulumi.Input[str] portal_addr6: IPv6 address (or FQDN) of authentication portal.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if groups is not None:
            pulumi.set(__self__, "groups", groups)
        if identity_based_route is not None:
            pulumi.set(__self__, "identity_based_route", identity_based_route)
        if portal_addr is not None:
            pulumi.set(__self__, "portal_addr", portal_addr)
        if portal_addr6 is not None:
            pulumi.set(__self__, "portal_addr6", portal_addr6)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter
    def groups(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]]]:
        """
        Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        """
        return pulumi.get(self, "groups")

    @groups.setter
    def groups(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FirewallAuthPortalGroupArgs']]]]):
        pulumi.set(self, "groups", value)

    @property
    @pulumi.getter(name="identityBasedRoute")
    def identity_based_route(self) -> Optional[pulumi.Input[str]]:
        """
        Name of the identity-based route that applies to this portal.
        """
        return pulumi.get(self, "identity_based_route")

    @identity_based_route.setter
    def identity_based_route(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "identity_based_route", value)

    @property
    @pulumi.getter(name="portalAddr")
    def portal_addr(self) -> Optional[pulumi.Input[str]]:
        """
        Address (or FQDN) of the authentication portal.
        """
        return pulumi.get(self, "portal_addr")

    @portal_addr.setter
    def portal_addr(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "portal_addr", value)

    @property
    @pulumi.getter(name="portalAddr6")
    def portal_addr6(self) -> Optional[pulumi.Input[str]]:
        """
        IPv6 address (or FQDN) of authentication portal.
        """
        return pulumi.get(self, "portal_addr6")

    @portal_addr6.setter
    def portal_addr6(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "portal_addr6", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class FirewallAuthPortal(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FirewallAuthPortalGroupArgs']]]]] = None,
                 identity_based_route: Optional[pulumi.Input[str]] = None,
                 portal_addr: Optional[pulumi.Input[str]] = None,
                 portal_addr6: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure firewall authentication portals.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_fortios as fortios

        trname = fortios.FirewallAuthPortal("trname",
            groups=[fortios.FirewallAuthPortalGroupArgs(
                name="Guest-group",
            )],
            portal_addr="1.1.1.1")
        ```

        ## Import

        Firewall AuthPortal can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/firewallAuthPortal:FirewallAuthPortal labelname FirewallAuthPortal
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FirewallAuthPortalGroupArgs']]]] groups: Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        :param pulumi.Input[str] identity_based_route: Name of the identity-based route that applies to this portal.
        :param pulumi.Input[str] portal_addr: Address (or FQDN) of the authentication portal.
        :param pulumi.Input[str] portal_addr6: IPv6 address (or FQDN) of authentication portal.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[FirewallAuthPortalArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure firewall authentication portals.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_fortios as fortios

        trname = fortios.FirewallAuthPortal("trname",
            groups=[fortios.FirewallAuthPortalGroupArgs(
                name="Guest-group",
            )],
            portal_addr="1.1.1.1")
        ```

        ## Import

        Firewall AuthPortal can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/firewallAuthPortal:FirewallAuthPortal labelname FirewallAuthPortal
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param FirewallAuthPortalArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FirewallAuthPortalArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FirewallAuthPortalGroupArgs']]]]] = None,
                 identity_based_route: Optional[pulumi.Input[str]] = None,
                 portal_addr: Optional[pulumi.Input[str]] = None,
                 portal_addr6: Optional[pulumi.Input[str]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FirewallAuthPortalArgs.__new__(FirewallAuthPortalArgs)

            __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
            __props__.__dict__["groups"] = groups
            __props__.__dict__["identity_based_route"] = identity_based_route
            __props__.__dict__["portal_addr"] = portal_addr
            __props__.__dict__["portal_addr6"] = portal_addr6
            __props__.__dict__["vdomparam"] = vdomparam
        super(FirewallAuthPortal, __self__).__init__(
            'fortios:index/firewallAuthPortal:FirewallAuthPortal',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
            groups: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FirewallAuthPortalGroupArgs']]]]] = None,
            identity_based_route: Optional[pulumi.Input[str]] = None,
            portal_addr: Optional[pulumi.Input[str]] = None,
            portal_addr6: Optional[pulumi.Input[str]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'FirewallAuthPortal':
        """
        Get an existing FirewallAuthPortal resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['FirewallAuthPortalGroupArgs']]]] groups: Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        :param pulumi.Input[str] identity_based_route: Name of the identity-based route that applies to this portal.
        :param pulumi.Input[str] portal_addr: Address (or FQDN) of the authentication portal.
        :param pulumi.Input[str] portal_addr6: IPv6 address (or FQDN) of authentication portal.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FirewallAuthPortalState.__new__(_FirewallAuthPortalState)

        __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
        __props__.__dict__["groups"] = groups
        __props__.__dict__["identity_based_route"] = identity_based_route
        __props__.__dict__["portal_addr"] = portal_addr
        __props__.__dict__["portal_addr6"] = portal_addr6
        __props__.__dict__["vdomparam"] = vdomparam
        return FirewallAuthPortal(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> pulumi.Output[Optional[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @property
    @pulumi.getter
    def groups(self) -> pulumi.Output[Optional[Sequence['outputs.FirewallAuthPortalGroup']]]:
        """
        Firewall user groups permitted to authenticate through this portal. Separate group names with spaces. The structure of `groups` block is documented below.
        """
        return pulumi.get(self, "groups")

    @property
    @pulumi.getter(name="identityBasedRoute")
    def identity_based_route(self) -> pulumi.Output[str]:
        """
        Name of the identity-based route that applies to this portal.
        """
        return pulumi.get(self, "identity_based_route")

    @property
    @pulumi.getter(name="portalAddr")
    def portal_addr(self) -> pulumi.Output[str]:
        """
        Address (or FQDN) of the authentication portal.
        """
        return pulumi.get(self, "portal_addr")

    @property
    @pulumi.getter(name="portalAddr6")
    def portal_addr6(self) -> pulumi.Output[str]:
        """
        IPv6 address (or FQDN) of authentication portal.
        """
        return pulumi.get(self, "portal_addr6")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

