# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs

__all__ = [
    'GetFirewallInternetServiceDefinitionResult',
    'AwaitableGetFirewallInternetServiceDefinitionResult',
    'get_firewall_internet_service_definition',
    'get_firewall_internet_service_definition_output',
]

@pulumi.output_type
class GetFirewallInternetServiceDefinitionResult:
    """
    A collection of values returned by GetFirewallInternetServiceDefinition.
    """
    def __init__(__self__, entries=None, fosid=None, id=None, vdomparam=None):
        if entries and not isinstance(entries, list):
            raise TypeError("Expected argument 'entries' to be a list")
        pulumi.set(__self__, "entries", entries)
        if fosid and not isinstance(fosid, int):
            raise TypeError("Expected argument 'fosid' to be a int")
        pulumi.set(__self__, "fosid", fosid)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if vdomparam and not isinstance(vdomparam, str):
            raise TypeError("Expected argument 'vdomparam' to be a str")
        pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def entries(self) -> Sequence['outputs.GetFirewallInternetServiceDefinitionEntryResult']:
        """
        Protocol and port information in an Internet Service entry. The structure of `entry` block is documented below.
        """
        return pulumi.get(self, "entries")

    @property
    @pulumi.getter
    def fosid(self) -> int:
        """
        Internet Service application list ID.
        """
        return pulumi.get(self, "fosid")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[str]:
        return pulumi.get(self, "vdomparam")


class AwaitableGetFirewallInternetServiceDefinitionResult(GetFirewallInternetServiceDefinitionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetFirewallInternetServiceDefinitionResult(
            entries=self.entries,
            fosid=self.fosid,
            id=self.id,
            vdomparam=self.vdomparam)


def get_firewall_internet_service_definition(fosid: Optional[int] = None,
                                             vdomparam: Optional[str] = None,
                                             opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetFirewallInternetServiceDefinitionResult:
    """
    Use this data source to get information on an fortios firewall internetservicedefinition


    :param int fosid: Specify the fosid of the desired firewall internetservicedefinition.
    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    __args__ = dict()
    __args__['fosid'] = fosid
    __args__['vdomparam'] = vdomparam
    if opts is None:
        opts = pulumi.InvokeOptions()
    if opts.version is None:
        opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
    __ret__ = pulumi.runtime.invoke('fortios:index/getFirewallInternetServiceDefinition:GetFirewallInternetServiceDefinition', __args__, opts=opts, typ=GetFirewallInternetServiceDefinitionResult).value

    return AwaitableGetFirewallInternetServiceDefinitionResult(
        entries=__ret__.entries,
        fosid=__ret__.fosid,
        id=__ret__.id,
        vdomparam=__ret__.vdomparam)


@_utilities.lift_output_func(get_firewall_internet_service_definition)
def get_firewall_internet_service_definition_output(fosid: Optional[pulumi.Input[int]] = None,
                                                    vdomparam: Optional[pulumi.Input[Optional[str]]] = None,
                                                    opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetFirewallInternetServiceDefinitionResult]:
    """
    Use this data source to get information on an fortios firewall internetservicedefinition


    :param int fosid: Specify the fosid of the desired firewall internetservicedefinition.
    :param str vdomparam: Specifies the vdom to which the data source will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
    """
    ...
