# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities
from . import outputs
from ._inputs import *

__all__ = ['WebProxyForwardServerGroupArgs', 'WebProxyForwardServerGroup']

@pulumi.input_type
class WebProxyForwardServerGroupArgs:
    def __init__(__self__, *,
                 affinity: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 group_down_option: Optional[pulumi.Input[str]] = None,
                 ldb_method: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 server_lists: Optional[pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a WebProxyForwardServerGroup resource.
        :param pulumi.Input[str] affinity: Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[str] group_down_option: Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        :param pulumi.Input[str] ldb_method: Load balance method: weighted or least-session.
        :param pulumi.Input[str] name: Forward server name.
        :param pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]] server_lists: Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if affinity is not None:
            pulumi.set(__self__, "affinity", affinity)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if group_down_option is not None:
            pulumi.set(__self__, "group_down_option", group_down_option)
        if ldb_method is not None:
            pulumi.set(__self__, "ldb_method", ldb_method)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if server_lists is not None:
            pulumi.set(__self__, "server_lists", server_lists)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def affinity(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "affinity")

    @affinity.setter
    def affinity(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "affinity", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="groupDownOption")
    def group_down_option(self) -> Optional[pulumi.Input[str]]:
        """
        Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        """
        return pulumi.get(self, "group_down_option")

    @group_down_option.setter
    def group_down_option(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_down_option", value)

    @property
    @pulumi.getter(name="ldbMethod")
    def ldb_method(self) -> Optional[pulumi.Input[str]]:
        """
        Load balance method: weighted or least-session.
        """
        return pulumi.get(self, "ldb_method")

    @ldb_method.setter
    def ldb_method(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ldb_method", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Forward server name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="serverLists")
    def server_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]]]:
        """
        Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        """
        return pulumi.get(self, "server_lists")

    @server_lists.setter
    def server_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]]]):
        pulumi.set(self, "server_lists", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


@pulumi.input_type
class _WebProxyForwardServerGroupState:
    def __init__(__self__, *,
                 affinity: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 group_down_option: Optional[pulumi.Input[str]] = None,
                 ldb_method: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 server_lists: Optional[pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering WebProxyForwardServerGroup resources.
        :param pulumi.Input[str] affinity: Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[str] group_down_option: Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        :param pulumi.Input[str] ldb_method: Load balance method: weighted or least-session.
        :param pulumi.Input[str] name: Forward server name.
        :param pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]] server_lists: Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        if affinity is not None:
            pulumi.set(__self__, "affinity", affinity)
        if dynamic_sort_subtable is not None:
            pulumi.set(__self__, "dynamic_sort_subtable", dynamic_sort_subtable)
        if group_down_option is not None:
            pulumi.set(__self__, "group_down_option", group_down_option)
        if ldb_method is not None:
            pulumi.set(__self__, "ldb_method", ldb_method)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if server_lists is not None:
            pulumi.set(__self__, "server_lists", server_lists)
        if vdomparam is not None:
            pulumi.set(__self__, "vdomparam", vdomparam)

    @property
    @pulumi.getter
    def affinity(self) -> Optional[pulumi.Input[str]]:
        """
        Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "affinity")

    @affinity.setter
    def affinity(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "affinity", value)

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> Optional[pulumi.Input[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @dynamic_sort_subtable.setter
    def dynamic_sort_subtable(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "dynamic_sort_subtable", value)

    @property
    @pulumi.getter(name="groupDownOption")
    def group_down_option(self) -> Optional[pulumi.Input[str]]:
        """
        Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        """
        return pulumi.get(self, "group_down_option")

    @group_down_option.setter
    def group_down_option(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "group_down_option", value)

    @property
    @pulumi.getter(name="ldbMethod")
    def ldb_method(self) -> Optional[pulumi.Input[str]]:
        """
        Load balance method: weighted or least-session.
        """
        return pulumi.get(self, "ldb_method")

    @ldb_method.setter
    def ldb_method(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ldb_method", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        Forward server name.
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter(name="serverLists")
    def server_lists(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]]]:
        """
        Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        """
        return pulumi.get(self, "server_lists")

    @server_lists.setter
    def server_lists(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['WebProxyForwardServerGroupServerListArgs']]]]):
        pulumi.set(self, "server_lists", value)

    @property
    @pulumi.getter
    def vdomparam(self) -> Optional[pulumi.Input[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

    @vdomparam.setter
    def vdomparam(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vdomparam", value)


class WebProxyForwardServerGroup(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 affinity: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 group_down_option: Optional[pulumi.Input[str]] = None,
                 ldb_method: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 server_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['WebProxyForwardServerGroupServerListArgs']]]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        Configure a forward server group consisting or multiple forward servers. Supports failover and load balancing.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_fortios as fortios

        trname1_web_proxy_forward_server = fortios.WebProxyForwardServer("trname1WebProxyForwardServer",
            addr_type="fqdn",
            healthcheck="disable",
            ip="0.0.0.0",
            monitor="http://www.google.com",
            port=1128,
            server_down_option="block")
        trname1_web_proxy_forward_server_group = fortios.WebProxyForwardServerGroup("trname1WebProxyForwardServerGroup",
            affinity="disable",
            group_down_option="block",
            ldb_method="weighted",
            server_lists=[fortios.WebProxyForwardServerGroupServerListArgs(
                name=trname1_web_proxy_forward_server.name,
                weight=12,
            )])
        ```

        ## Import

        WebProxy ForwardServerGroup can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/webProxyForwardServerGroup:WebProxyForwardServerGroup labelname {{name}}
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] affinity: Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[str] group_down_option: Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        :param pulumi.Input[str] ldb_method: Load balance method: weighted or least-session.
        :param pulumi.Input[str] name: Forward server name.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['WebProxyForwardServerGroupServerListArgs']]]] server_lists: Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: Optional[WebProxyForwardServerGroupArgs] = None,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Configure a forward server group consisting or multiple forward servers. Supports failover and load balancing.

        ## Example Usage

        ```python
        import pulumi
        import pulumi_fortios as fortios

        trname1_web_proxy_forward_server = fortios.WebProxyForwardServer("trname1WebProxyForwardServer",
            addr_type="fqdn",
            healthcheck="disable",
            ip="0.0.0.0",
            monitor="http://www.google.com",
            port=1128,
            server_down_option="block")
        trname1_web_proxy_forward_server_group = fortios.WebProxyForwardServerGroup("trname1WebProxyForwardServerGroup",
            affinity="disable",
            group_down_option="block",
            ldb_method="weighted",
            server_lists=[fortios.WebProxyForwardServerGroupServerListArgs(
                name=trname1_web_proxy_forward_server.name,
                weight=12,
            )])
        ```

        ## Import

        WebProxy ForwardServerGroup can be imported using any of these accepted formats$ export "FORTIOS_IMPORT_TABLE"="true"

        ```sh
         $ pulumi import fortios:index/webProxyForwardServerGroup:WebProxyForwardServerGroup labelname {{name}}
        ```

         $ unset "FORTIOS_IMPORT_TABLE"

        :param str resource_name: The name of the resource.
        :param WebProxyForwardServerGroupArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(WebProxyForwardServerGroupArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 affinity: Optional[pulumi.Input[str]] = None,
                 dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
                 group_down_option: Optional[pulumi.Input[str]] = None,
                 ldb_method: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 server_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['WebProxyForwardServerGroupServerListArgs']]]]] = None,
                 vdomparam: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = _utilities.get_version()
        if opts.plugin_download_url is None:
            opts.plugin_download_url = _utilities.get_plugin_download_url()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = WebProxyForwardServerGroupArgs.__new__(WebProxyForwardServerGroupArgs)

            __props__.__dict__["affinity"] = affinity
            __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
            __props__.__dict__["group_down_option"] = group_down_option
            __props__.__dict__["ldb_method"] = ldb_method
            __props__.__dict__["name"] = name
            __props__.__dict__["server_lists"] = server_lists
            __props__.__dict__["vdomparam"] = vdomparam
        super(WebProxyForwardServerGroup, __self__).__init__(
            'fortios:index/webProxyForwardServerGroup:WebProxyForwardServerGroup',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            affinity: Optional[pulumi.Input[str]] = None,
            dynamic_sort_subtable: Optional[pulumi.Input[str]] = None,
            group_down_option: Optional[pulumi.Input[str]] = None,
            ldb_method: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            server_lists: Optional[pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['WebProxyForwardServerGroupServerListArgs']]]]] = None,
            vdomparam: Optional[pulumi.Input[str]] = None) -> 'WebProxyForwardServerGroup':
        """
        Get an existing WebProxyForwardServerGroup resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] affinity: Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        :param pulumi.Input[str] dynamic_sort_subtable: true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        :param pulumi.Input[str] group_down_option: Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        :param pulumi.Input[str] ldb_method: Load balance method: weighted or least-session.
        :param pulumi.Input[str] name: Forward server name.
        :param pulumi.Input[Sequence[pulumi.Input[pulumi.InputType['WebProxyForwardServerGroupServerListArgs']]]] server_lists: Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        :param pulumi.Input[str] vdomparam: Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _WebProxyForwardServerGroupState.__new__(_WebProxyForwardServerGroupState)

        __props__.__dict__["affinity"] = affinity
        __props__.__dict__["dynamic_sort_subtable"] = dynamic_sort_subtable
        __props__.__dict__["group_down_option"] = group_down_option
        __props__.__dict__["ldb_method"] = ldb_method
        __props__.__dict__["name"] = name
        __props__.__dict__["server_lists"] = server_lists
        __props__.__dict__["vdomparam"] = vdomparam
        return WebProxyForwardServerGroup(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter
    def affinity(self) -> pulumi.Output[str]:
        """
        Enable/disable affinity, attaching a source-ip's traffic to the assigned forwarding server until the forward-server-affinity-timeout is reached (under web-proxy global). Valid values: `enable`, `disable`.
        """
        return pulumi.get(self, "affinity")

    @property
    @pulumi.getter(name="dynamicSortSubtable")
    def dynamic_sort_subtable(self) -> pulumi.Output[Optional[str]]:
        """
        true or false, set this parameter to true when using dynamic for_each + toset to configure and sort sub-tables, please do not set this parameter when configuring static sub-tables.
        """
        return pulumi.get(self, "dynamic_sort_subtable")

    @property
    @pulumi.getter(name="groupDownOption")
    def group_down_option(self) -> pulumi.Output[str]:
        """
        Action to take when all of the servers in the forward server group are down: block sessions until at least one server is back up or pass sessions to their destination. Valid values: `block`, `pass`.
        """
        return pulumi.get(self, "group_down_option")

    @property
    @pulumi.getter(name="ldbMethod")
    def ldb_method(self) -> pulumi.Output[str]:
        """
        Load balance method: weighted or least-session.
        """
        return pulumi.get(self, "ldb_method")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        Forward server name.
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter(name="serverLists")
    def server_lists(self) -> pulumi.Output[Optional[Sequence['outputs.WebProxyForwardServerGroupServerList']]]:
        """
        Add web forward servers to a list to form a server group. Optionally assign weights to each server. The structure of `server_list` block is documented below.
        """
        return pulumi.get(self, "server_lists")

    @property
    @pulumi.getter
    def vdomparam(self) -> pulumi.Output[Optional[str]]:
        """
        Specifies the vdom to which the resource will be applied when the FortiGate unit is running in VDOM mode. Only one vdom can be specified. If you want to inherit the vdom configuration of the provider, please do not set this parameter.
        """
        return pulumi.get(self, "vdomparam")

